#!/bin/sh

GNUPLOT=gnuplot

if test $# -ne 1
    then
    echo "Usage: dark.sh filename.dat" 1>&2
    exit 1
fi

#$BF|IU=g$G%=!<%H$9$k(B
sort -k 2 -o $1 $1

#$B%F%s%]%i%j%U%!%$%k(B
TMPDATA="hage.hage"

#gnuplot$B$GFI$_$d$9$$7A$KJQ49$9$k(B
#awk '{print $1, $2":"$3, $4, $5, $6, $7, $8, $9, $10}' $1 > ${TMPDATA}
#awk '{print $1, $11":"$12, $4, $5, $6, $7, $8, $9, $10}' $1 > ${TMPDATA}
#awk '{print $1, $2, $4, $5, $6, $7, $8, $9, $10}' $1 | tr 'T' ':' | tr '2007-10-' '2007:10:' > ${TMPDATA}


uniq $1 | cut -d ' ' -f1 > "filename"
uniq $1 | cut -d ' ' -f 2 | tr '\.' ' ' | cut -d ' ' -f 1 > "time"
uniq $1 | cut -d ' ' -f4- > "data"

cat time | tr '-' ':' | tr 'T' ':' > time.convert
paste -d ' ' filename time.convert data >  ${TMPDATA}

rm -rf filename
rm -rf time
rm -rf data
rm -rf time.convert

${GNUPLOT} -persist <<EOF
set xdata time
set timefmt "%Y:%m:%d:%H:%M:%S"
set xlabel "Date [UT]"
set ylabel "Temperature [K]"
set y2label "DARK DN [count]"
set y2tics
set ytics nomirror
#plot "${TMPDATA}" using 2:3 axis x1y1 title "NTP1T", "${TMPDATA}" using 2:4 axis x1y1 title "STP1T", "${TMPDATA}" using 2:5 axis x1y1 title "LTP1T", "${TMPDATA}" using 2:6:7 axis x1y2 title "IMAG MED DARK" w yerrorbars, "${TMPDATA}" using 2:8:9 axis x1y2 title "SLIT MED DARK" w yerrorbars
# for NIR
#set y2range [0:20]
#set yrange [10.2:10.8]
#plot "${TMPDATA}" using 2:3 axis x1y1 title "NTP1T" w lines, "${TMPDATA}" using 2:(\$6/4) axis x1y2 title "IMAG MED DARK" w lines, "${TMPDATA}" using 2:(\$8/4) axis x1y2 title "SLIT MED DARK" w lines
plot "${TMPDATA}" using 2:3 axis x1y1 title "NTP1T" w lines, "${TMPDATA}" using 2:6 axis x1y2 title "IMAG MED DARK" w lines, "${TMPDATA}" using 2:8 axis x1y2 title "SLIT MED DARK" w lines
# for MIRS
#set y2range [30:55]
#set yrange [6.5:7.5]
#plot "${TMPDATA}" using 2:4 axis x1y1 title "STP1T" w lines, "${TMPDATA}" using 2:6 axis x1y2 title "IMAG MED DARK" w lines, "${TMPDATA}" using 2:8 axis x1y2 title "SLIT MED DARK" w lines
# for MIRL
#set y2range [35:65]
#set yrange [6.2:7.2]
#plot "${TMPDATA}" using 2:5 axis x1y1 title "LTP1T" w lines, "${TMPDATA}" using 2:6 axis x1y2 title "IMAG MED DARK" w lines, "${TMPDATA}" using 2:8 axis x1y2 title "SLIT MED DARK" w lines

set terminal postscript color
set output "out.ps"
replot
set terminal png
set output "out.png"
replot
EOF

#\rm -rf ${TMPDATA}
