PRO irc_imcombine,inimage,avgimage,rmsimage

; do image combine over all exposure_cycles for each subframe_id
;
; input: inimage[x,y,subframe_id,exposure_cycle]
;    subframe_id=0,1 for N
;    subframe_id=0,1,2,3 for M
;    exposure_cycle=0,1,2,...N
; output: avgimage[x,y,subframe_id], rmsimage[x,y,subframe_id]

subframe_id_max=n_elements(inimage[0,0,*,0]) ; 4 for MIR, 2 for NIR
ncol=n_elements(inimage[*,0,0,0])
nrow=n_elements(inimage[0,*,0,0])

avgimage=fltarr(ncol,nrow,subframe_id_max)
rmsimage=fltarr(ncol,nrow,subframe_id_max)

for subframe_id=0,subframe_id_max-1 do begin

    irc_make_rmsimage,inimage[*,*,subframe_id,*],rmsimage_tmp
    irc_make_avgimage,inimage[*,*,subframe_id,*],avgimage_tmp

    rmsimage[*,*,subframe_id]=rmsimage_tmp
    avgimage[*,*,subframe_id]=avgimage_tmp

endfor

END
