PRO write_spec_in_adu,lambda,flux_in_adu,d_flux_n_in_adu,d_flux_p_in_adu, $
                      filename=filename,no_wl_limit=no_wl_limit,redshift=redshift

; Written by S. Baba, 2014/01/19
; Write spectrum on an ascii file in ADU unit

  s=size(flux_in_adu)
  if ~ defined(d_flux_n_in_adu) then d_flux_n_in_adu=fltarr(s[1]) ; dummy array
  if ~ defined(d_flux_p_in_adu) then d_flux_p_in_adu=fltarr(s[1]) ; dummy array
 
  if ~ defined(redshift) then redshift=0.

  if ~ defined(filename) then $
     outfilename = DIALOG_PICKFILE (FILTER = '*.spc',title='Spectrum File Name',path=!IRC_SPECRED_DIR.calibdir) $
  else outfilename=filename


  if s[0] EQ 1 then begin       ; single source
     GET_LUN,U & openw,U,outfilename
     for i=0,n_elements(lambda)-1 do begin
        if keyword_set(no_wl_limit) || $
           (lambda[i] GT !IRC_SPECRED_SPECPARAM.w_cover_2[0] && lambda[i] LT !IRC_SPECRED_SPECPARAM.w_cover_2[1]) then $
              printf,U,lambda[i]/(1.+redshift),flux_in_adu[i],d_flux_n_in_adu[i],d_flux_p_in_adu[i]
     endfor
     close,U & FREE_LUN,U
     
  endif else begin              ; multiple sources
     for source_id=0,s[2]-1 do begin
        outfilename=!IRC_SPECRED_DIR.tmpdir+'/tmp_'+string(source_id)+'.spc'
        GET_LUN,U & openw,U,outfilename
        for i=0,n_elements(lambda)-1 do begin
           if  keyword_set(no_wl_limit) || $
              (lambda[i] GT !IRC_SPECRED_SPECPARAM.w_cover_2[0] && lambda[i] LT !IRC_SPECRED_SPECPARAM.w_cover_2[1]) then $
                 printf,U,lambda[i]/(1.+redshift),flux_in_adu[i,source_id],d_flux_n_in_adu[i_source_id],d_flux_p_in_adu[i_source_id]
        endfor
        close,U & FREE_LUN,U
     endfor
     
  endelse
  
END
