PRO iispec_auto

data_dir = getenv('IRC_SPECRED_DATADIR')

list_file = data_dir + 'list.txt'
done_list = data_dir + 'done_list.txt'

;;; read ID number and AOT list
readcol, list_file, format='A,A,A,A', ID, subID, AOTpar1, AOTpar2,delimiter=',', COMMENT='#', /silent

ID    = long(ID)
subID = long(subID)

;;; execute toolkit 
i=0
REPEAT BEGIN

   spawn,'date +%Y/%m/%d_%H:%M:%S',datestring0

   if AOTpar1[i] eq 'a' then begin
      iispec, ID[i], subID[i],      /non_interactive, /no_show_ds9, /use_all_images, /no_message_finish, /no_message_window
   endif

   if AOTpar1[i] eq 'b' then begin
      iispec, ID[i], subID[i], /NG, /non_interactive, /no_show_ds9, /use_all_images, /no_message_finish, /no_message_window
   endif

   if AOTpar1[i] eq 'c' then begin
      iispec, ID[i], subID[i],      /non_interactive, /no_show_ds9, /use_all_images, /no_message_finish, /no_message_window, /no_database_check
      iispec, ID[i], subID[i], /NG, /non_interactive, /no_show_ds9, /use_all_images, /no_message_finish, /no_message_window, /no_database_check
   endif

   spawn,'date +%Y/%m/%d_%H:%M:%S',datestring

   ; succeeded record
   openw,U,done_list,/get_lun,/Append
   printf,U, STRING(ID[i]) + '  ' + STRING(subID[i]) + '   ' + STRING(datestring0) + '   ' + STRING(datestring)
   close,U
   free_lun,U

  i=i+1

ENDREP UNTIL i EQ N_ELEMENTS(ID) 

END
